"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _multipleChoiceList = _interopRequireDefault(require("@data-driven-forms/common/multiple-choice-list"));

var _Checkbox = _interopRequireDefault(require("carbon-components-react/lib/components/Checkbox/Checkbox.js"));

var _FormGroup = _interopRequireDefault(require("carbon-components-react/lib/components/FormGroup/FormGroup.js"));

var _withDescription = _interopRequireDefault(require("../with-description"));

var _prepareProps = _interopRequireWildcard(require("../prepare-props"));

var _helperTextBlock = _interopRequireDefault(require("../helper-text-block/helper-text-block"));

var _excluded = ["input", "meta", "validateOnMount", "helperText", "WrapperProps"],
    _excluded2 = ["value", "name"],
    _excluded3 = ["label", "isDisabled", "id", "meta", "option", "onChange"],
    _excluded4 = ["options"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var Wrapper = function Wrapper(_ref) {
  var label = _ref.label,
      description = _ref.description,
      children = _ref.children,
      helperText = _ref.helperText,
      error = _ref.error,
      showError = _ref.showError,
      isRequired = _ref.isRequired;
  return /*#__PURE__*/_react["default"].createElement(_FormGroup["default"], {
    legendText: description ? /*#__PURE__*/_react["default"].createElement(_withDescription["default"], {
      labelText: (0, _prepareProps.buildLabel)(label, isRequired),
      description: description
    }) : (0, _prepareProps.buildLabel)(label, isRequired)
  }, children, /*#__PURE__*/_react["default"].createElement(_helperTextBlock["default"], {
    helperText: helperText,
    errorText: showError && error
  }));
};

Wrapper.propTypes = {
  label: _propTypes["default"].node,
  children: _propTypes["default"].node,
  description: _propTypes["default"].node,
  helperText: _propTypes["default"].node,
  error: _propTypes["default"].node,
  showError: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool
};

var SingleCheckbox = function SingleCheckbox(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])((0, _prepareProps["default"])(_objectSpread(_objectSpread({}, props), {}, {
    type: 'checkbox'
  }))),
      input = _useFieldApi.input,
      meta = _useFieldApi.meta,
      validateOnMount = _useFieldApi.validateOnMount,
      helperText = _useFieldApi.helperText,
      WrapperProps = _useFieldApi.WrapperProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded);

  var invalid = (meta.touched || validateOnMount) && (meta.error || meta.submitError);
  var warnText = (meta.touched || validateOnMount) && meta.warning;
  return /*#__PURE__*/_react["default"].createElement("div", WrapperProps, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], (0, _extends2["default"])({}, input, {
    id: input.name
  }, rest)), /*#__PURE__*/_react["default"].createElement(_helperTextBlock["default"], {
    helperText: helperText,
    errorText: invalid,
    warnText: warnText
  }));
};

var SingleCheckboxInCommon = function SingleCheckboxInCommon(_ref2) {
  var label = _ref2.label,
      isDisabled = _ref2.isDisabled,
      id = _ref2.id,
      meta = _ref2.meta,
      _ref2$option = _ref2.option,
      value = _ref2$option.value,
      name = _ref2$option.name,
      rest = (0, _objectWithoutProperties2["default"])(_ref2$option, _excluded2),
      _onChange = _ref2.onChange,
      props = (0, _objectWithoutProperties2["default"])(_ref2, _excluded3);
  return /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], (0, _extends2["default"])({
    id: id,
    labelText: label,
    disabled: isDisabled
  }, props, rest, {
    onChange: function onChange(_value, _name, event) {
      return _onChange(event);
    }
  }));
};

SingleCheckboxInCommon.propTypes = {
  label: _propTypes["default"].node,
  input: _propTypes["default"].object,
  isDisabled: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  name: _propTypes["default"].string,
  id: _propTypes["default"].string,
  WrapperProps: _propTypes["default"].object,
  meta: _propTypes["default"].object,
  option: _propTypes["default"].object,
  onChange: _propTypes["default"].func
};

var Checkbox = function Checkbox(_ref3) {
  var options = _ref3.options,
      props = (0, _objectWithoutProperties2["default"])(_ref3, _excluded4);
  return options ? /*#__PURE__*/_react["default"].createElement(_multipleChoiceList["default"], (0, _extends2["default"])({
    options: options
  }, props, {
    Wrapper: Wrapper,
    Checkbox: SingleCheckboxInCommon
  })) : /*#__PURE__*/_react["default"].createElement(SingleCheckbox, props);
};

Checkbox.propTypes = {
  options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    label: _propTypes["default"].node,
    value: _propTypes["default"].any
  }))
};
var _default = Checkbox;
exports["default"] = _default;