"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactJssCjs = require("react-jss/dist/react-jss.cjs.js");

var useStyles = (0, _reactJssCjs.createUseStyles)({
  helperTextStyle: {
    color: '#da1e28',
    display: 'block',
    overflow: 'initial'
  }
});

var HelperTextBlock = function HelperTextBlock(_ref) {
  var helperText = _ref.helperText,
      errorText = _ref.errorText,
      warnText = _ref.warnText;

  var _useStyles = useStyles(),
      helperTextStyle = _useStyles.helperTextStyle;

  if (errorText) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "bx--form-requirement ddorg__carbon-error-helper-text ".concat(helperTextStyle)
    }, errorText);
  }

  if (warnText) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "bx--form-requirement ddorg__carbon-error-helper-text ".concat(helperTextStyle)
    }, warnText);
  }

  if (helperText) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "bx--form__helper-text"
    }, helperText);
  }

  return null;
};

HelperTextBlock.propTypes = {
  helperText: _propTypes["default"].node,
  errorText: _propTypes["default"].node,
  warnText: _propTypes["default"].node
};
var _default = HelperTextBlock;
exports["default"] = _default;