"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _clsx = _interopRequireDefault(require("clsx"));

var _reactJssCjs = require("react-jss/dist/react-jss.cjs.js");

var _useFormApi = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-form-api"));

var _excluded = ["fields", "component", "title", "description", "TitleElement", "DescriptionElement", "TitleProps", "DescriptionProps", "HeaderProps"];
var useStyles = (0, _reactJssCjs.createUseStyles)({
  subForm: {
    '&>:not(:last-child)': {
      marginBottom: 32
    }
  }
});

var SubForm = function SubForm(_ref) {
  var fields = _ref.fields,
      component = _ref.component,
      title = _ref.title,
      description = _ref.description,
      TitleElement = _ref.TitleElement,
      DescriptionElement = _ref.DescriptionElement,
      TitleProps = _ref.TitleProps,
      DescriptionProps = _ref.DescriptionProps,
      HeaderProps = _ref.HeaderProps,
      rest = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  var formOptions = (0, _useFormApi["default"])();

  var _useStyles = useStyles(),
      tab = _useStyles.tab;

  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, rest, {
    className: (0, _clsx["default"])(tab, rest.className)
  }), (title || description) && /*#__PURE__*/_react["default"].createElement("div", HeaderProps, title && /*#__PURE__*/_react["default"].createElement(TitleElement, TitleProps, title), description && /*#__PURE__*/_react["default"].createElement(DescriptionElement, DescriptionProps, description)), formOptions.renderForm(fields, formOptions));
};

SubForm.propTypes = {
  fields: _propTypes["default"].array,
  component: _propTypes["default"].string,
  title: _propTypes["default"].node,
  description: _propTypes["default"].node,
  TitleElement: _propTypes["default"].string,
  DescriptionElement: _propTypes["default"].string,
  TitleProps: _propTypes["default"].object,
  DescriptionProps: _propTypes["default"].object,
  HeaderProps: _propTypes["default"].object
};
SubForm.defaultProps = {
  TitleElement: 'h3',
  DescriptionElement: 'p'
};
var _default = SubForm;
exports["default"] = _default;